8982 Support building with OpenSSL 1.1
[unleashed.git] / usr / src / cmd / diff3 / diff3.sh
blobf29059a5878904bc4d77608a1958522cc646528a
1 #!/usr/bin/sh
3 # CDDL HEADER START
5 # The contents of this file are subject to the terms of the
6 # Common Development and Distribution License, Version 1.0 only
7 # (the "License"). You may not use this file except in compliance
8 # with the License.
10 # You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
11 # or http://www.opensolaris.org/os/licensing.
12 # See the License for the specific language governing permissions
13 # and limitations under the License.
15 # When distributing Covered Code, include this CDDL HEADER in each
16 # file and include the License file at usr/src/OPENSOLARIS.LICENSE.
17 # If applicable, add the following below this CDDL HEADER, with the
18 # fields enclosed by brackets "[]" replaced with your own identifying
19 # information: Portions Copyright [yyyy] [name of copyright owner]
21 # CDDL HEADER END
23 # Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T
24 # All Rights Reserved
27 # Copyright (c) 1999, 2001 by Sun Microsystems, Inc.
28 # All rights reserved.
30 usage="usage: diff3 file1 file2 file3"
32 # mktmpdir - Create a private (mode 0700) temporary directory inside of /tmp
33 # for this process's temporary files. We set up a trap to remove the
34 # directory on exit (trap 0), and also on SIGHUP, SIGINT, SIGQUIT, SIGPIPE,
35 # and SIGTERM.
37 mktmpdir() {
38 tmpdir=/tmp/diff3.$$
39 trap '/usr/bin/rm -rf $tmpdir' 0 1 2 3 13 15
40 /usr/bin/mkdir -m 700 $tmpdir || exit 1
42 mktmpdir
45 case $1 in
46 -*)
47 e=$1
48 shift;;
49 esac
50 if [ $# != 3 ]; then
51 echo ${usage} 1>&2
52 exit 1
54 if [ \( -f $1 -o -c $1 \) -a \( -f $2 -o -c $2 \) -a \( -f $3 -o -c $3 \) ]; then
56 else
57 echo ${usage} 1>&2
58 exit 1
60 f1=$1 f2=$2 f3=$3
61 if [ -c $f1 ]
62 then
63 /usr/bin/cat $f1 > $tmpdir/d3c$$
64 f1=$tmpdir/d3c$$
66 if [ -c $f2 ]
67 then
68 /usr/bin/cat $f2 > $tmpdir/d3d$$
69 f2=$tmpdir/d3d$$
71 if [ -c $f3 ]
72 then
73 /usr/bin/cat $f3 > $tmpdir/d3e$$
74 f3=$tmpdir/d3e$$
77 /usr/bin/diff $f1 $f3 > $tmpdir/d3a$$ 2> $tmpdir/d3a$$.err
78 STATUS=$?
79 if [ $STATUS -eq 1 ]
80 then
81 /usr/bin/grep -q "^[<>]" $tmpdir/d3a$$
82 RET=$?
83 if [ $RET -eq 1 ]
84 then
85 /usr/bin/cat $tmpdir/d3a$$
86 exit $STATUS
89 if [ $RET -gt 1 ]
90 then
91 echo "diff3 failed" 1>&2
92 exit $STATUS
96 if [ $STATUS -gt 1 ]
97 then
98 /usr/bin/cat $tmpdir/d3a$$.err
99 exit $STATUS
102 /usr/bin/diff $f2 $f3 > $tmpdir/d3b$$ 2> $tmpdir/d3b$$.err
103 STATUS=$?
104 if [ $STATUS -eq 1 ]
105 then
106 /usr/bin/grep -q "^[<>]" $tmpdir/d3b$$
107 RET=$?
108 if [ $RET -eq 1 ]
109 then
110 /usr/bin/cat $tmpdir/d3b$$
111 exit $STATUS
114 if [ $RET -gt 1 ]
115 then
116 echo "diff3 failed" 1>&2
117 exit $STATUS
121 if [ $STATUS -gt 1 ]
122 then
123 /usr/bin/cat $tmpdir/d3b$$.err
124 exit $STATUS
127 /usr/lib/diff3prog $e $tmpdir/d3[ab]$$ $f1 $f2 $f3